package ru.dbotthepony.kstarbound.client.network.packets

import ru.dbotthepony.kstarbound.client.network.ClientConnection
import ru.dbotthepony.kstarbound.network.IClientPacket
import ru.dbotthepony.kstarbound.io.readChunkPos
import ru.dbotthepony.kstarbound.io.writeVec2i
import ru.dbotthepony.kstarbound.world.ChunkPos
import java.io.DataInputStream
import java.io.DataOutputStream
import kotlin.concurrent.withLock

class ForgetChunkPacket(val pos: ChunkPos) : IClientPacket {
	constructor(stream: DataInputStream) : this(stream.readChunkPos())

	override fun write(stream: DataOutputStream) {
		stream.writeVec2i(pos)
	}

	override fun play(connection: ClientConnection) {
		connection.client.mailbox.execute {
			val world = connection.client.world ?: return@execute
			world.chunkMap.remove(pos)

			world.forEachRenderRegion(pos) {
				it.notifyChunkForget()
			}
		}
	}
}
