package ru.dbotthepony.kstarbound.world

import ru.dbotthepony.kstarbound.world.api.ImmutableCell
import ru.dbotthepony.kstarbound.world.entities.AbstractEntity

fun interface IEntityAdditionListener {
	fun onEntityAdded(entity: AbstractEntity)
}

fun interface IEntityRemovalListener {
	fun onEntityRemoved(entity: AbstractEntity)
}

fun interface ICellChangeListener {
	fun onCellChanges(x: Int, y: Int, cell: ImmutableCell)
}

interface IChunkListener : IEntityAdditionListener, IEntityRemovalListener, ICellChangeListener
